program jatekom;

uses newdelay,crt,graph,rajz;

const
       htszin=1;
       rhtszin=14;
       falszin=9;
       kockaszin=3;
{       ugroido=600; vrakozsi id amg ugrik a nyussz}
       zuhanoido=70;
       szin=15;     {nyuszi sznmintja}
       tav=20;      {kockk nagysga}
       maxN=50;
       maxM=50;

Type
     sorok=array[1..maxM+2] of byte;
     TLab=array[1..maxN+2] of sorok;

var maxX,MaxY:integer;
    N,M:integer;
    c:char;
    x,y:integer;  {nyuszi tartzkodsi helye}
    i,j:integer;
    ok:integer;
    lab:Tlab;
    f:text;
    p:integer;    {akt plya szma}
    db:integer;
    lepesszam:integer;
    jobbranez:boolean;
    kilep:boolean;
    ax,ay:integer;
    s:string;
    r:integer;
    ugroido: integer; {vrakozsi id, amg a nyuszi lebeg}

procedure labirintbeolvas(var f:text; const p:integer);
var s  :string;
    b  :byte;
    ok:integer;
    filenev:string;
    x,y:integer;
begin
  str(p,filenev);
  filenev:='p'+filenev+'.txt';
  assign(f,filenev);
  reset(f);
  N:=22;
  M:=30;
  For x:=1 to N do     {=While not eof(f) do}
  begin
    readln(f,s);
    for y:=1 to M {=length(s)} do
    begin
      val(s[y],b,ok);
      lab[x,y]:=b;
    end;
  end;
  close(f);
end;

procedure atvalt(const i,j:integer; var x,y:integer);
begin
  y:=i*tav+3;
  x:=j*tav-1;
end;

procedure visszavalt(const x,y:integer; var i,j:integer);
begin
  i:=(y-3) div tav;
  j:=(x+1) div tav;
end;

procedure torles(const merre:integer; const szine:integer);
var i:integer;
              {1:itt, 2:jobbra, 3:balra, 4:fel, 5:le}
begin
  case merre of
    1:     {itt}
    begin
      setcolor(falszin);
      rectangle(x+1,y-3,x+tav+1,y+tav-3);
      setcolor(szine);
      for i:=-2 to tav-4 do
      begin
        line(x+2,y+i,x+tav,y+i);
      end;
    end;
    2:       {jobbra}
    begin
      setcolor(falszin);
      rectangle(x+1+tav,y-3,x+2*tav+1,y+tav-3);
      setcolor(szine);
      for i:=-2 to tav-4 do
      begin
        line(x+2+tav,y+i,x+2*tav,y+i);
      end;
    end;
    3:       {balra}
    begin
      setcolor(falszin);
      rectangle(x+1-tav,y-3,x+1,y+tav-3);
      setcolor(szine);
      for i:=-2 to tav-4 do
      begin
        line(x+2-tav,y+i,x,y+i);
      end;
    end;
    4:         {fel}
    begin
      setcolor(falszin);
      rectangle(x+1,y-3-tav,x+1,y+tav-3-tav);
      setcolor(szine);
      for i:=-2 to tav-4 do
      begin
        line(x+2,y+i-tav,x+tav,y+i-tav);
      end;
    end;
    5:          {le}
    begin
      setcolor(falszin);
      rectangle(x+1,y-3+tav,x+1,y+tav-3+tav);
      setcolor(szine);
      for i:=-2 to tav-4 do
      begin
        line(x+2,y+i+tav,x+tav,y+i+tav);
      end;
    end;
  end;
end;

procedure labirintrajzol;
var i,j:integer;
begin
  For i:=1 to N do
  begin
    for j:=1 to M do
    begin
      If lab[i,j]=1 then
        begin
          atvalt(i,j,x,y);
          torles(1,falszin);
        end
        else
          if lab[i,j]=2 then
            begin
              atvalt(i,j,x,y);
              repa(x,y);
            end
            else
              if lab[i,j]=3 then
              begin
                atvalt(i,j,x,y);
                torles(1,kockaszin);
              end;
    end;
  end;
end;

procedure Racs;
var i:integer;
begin
  setcolor(falszin);

  i:=tav;
  while i<=maxY do
  begin
    line(tav+1,i,maxX-tav-1,i);
    i:=i+tav;
  end;

  i:=tav;
  while i<=maxX do
  begin
    line(i,tav,i,maxY-tav-1);
    i:=i+tav;
  end;
end;

procedure grafikaira;
Var
  gd, gm : integer;
Begin
   DetectGraph(gd,gm);
   InitGraph(gd,gm,'c:\pascal\bgi');
   maxX:=getmaxX;
   maxY:=getmaxY;
End;

procedure szovegesre;
begin
  CloseGraph;
end;

procedure SzinesTeglalap(const bfx,bfy,jax,jay: integer; const milyen: string);
var i:integer;
begin
  randomize;
  If milyen='vizszintes' then
  begin
    for i:=0 to tav-1 do
    begin
      setcolor(random(14)+1);
      line(bfx,bfy+i,bfx+maxX,bfy+i);
    end;
  end
  else  {fggo"leges}
  begin
    for i:=0 to tav-1 do
    begin
      setcolor(random(14)+1);
      line(bfx+i,bfy,bfx+i,bfy+(maxY-tav-1));
    end;
  end;
end;

procedure repaszamolas;
var repaszam:string;
    i:integer;
begin
  setcolor(htszin);
  for i:=0 to 12 do line(8,3+i,136,3+i);
  setcolor(white);
  outtextxy(10,6,'Rpid szma: ');
  str(r,repaszam);
  outtextxy(120,6,repaszam);
end;

procedure gravitacio(const kie:string);
var ax,ay:integer;
begin
  if kie='nyuszko' then
  begin
    visszavalt(x,y,i,j);
    if (lab[i+1,j]=0) or (lab[i+1,j]=2) then
    begin
      while (lab[i+1,j]=0) or (lab[i+1,j]=2) do
      begin
        if lab[i+1,j]=2 then
        begin
          r:=r+1;
          repaszamolas;
          lab[i+1,j]:=0;
        end;
        torles(1,htszin);
        if jobbranez then jobbunyuszi(x,y+round(tav/2),szin)
                     else balunyuszi(x,y+round(tav/2),szin);
        delay(zuhanoido);
        torles(1,htszin);
        torles(5,htszin);
        y:=y+tav;
        if jobbranez then jobbnyuszi(x,y,szin)
                     else balnyuszi(x,y,szin);
        visszavalt(x,y,i,j);
      end;
    end;
  end
  else
  begin
    ax:=x;
    ay:=y;
    if jobbranez then
    begin
      x:=x+tav;
      visszavalt(x,y,i,j);
      if (lab[i+1,j]=0) or (lab[i+1,j]=2) then
      begin
        lab[i,j]:=0;
        while (lab[i+1,j]=0) or (lab[i+1,j]=2) do
        begin
          lab[i+1,j]:=0;
          torles(1,htszin);
          y:=y+tav;
          torles(1,kockaszin);
          delay(zuhanoido);
          visszavalt(x,y,i,j);
        end;
        lab[i,j]:=3;
      end;
    end
    else
    begin
      x:=x-tav;
      visszavalt(x,y,i,j);
      if (lab[i+1,j]=0) or (lab[i+1,j]=2) then
      begin
        lab[i,j]:=0;
        while (lab[i+1,j]=0) or (lab[i+1,j]=2) do
        begin
          lab[i+1,j]:=0;
          torles(1,htszin);
          y:=y+tav;
          torles(1,kockaszin);
          delay(zuhanoido);
          visszavalt(x,y,i,j);
        end;
        lab[i,j]:=3;
      end;
    end;
    x:=ax;
    y:=ay;
  end;
end;


procedure keret;
begin
  SetLineStyle(solidLn, 0, NormWidth);
  SzinesTeglalap(0,tav,tav,maxY-tav,'fuggoleges');
  SzinesTeglalap(maxX-tav,tav,maxX,maxY-tav,'fuggoleges');
  SzinesTeglalap(0,maxY-tav,maxX,maxY-1,'vizszintes');
  SzinesTeglalap(0,0,maxX,tav,'vizszintes');
end;

procedure Inical(const p:integer);
var i,j,h:integer;
      s:string;
begin
  labirintbeolvas(f,p);
  grafikaira;
  cleardevice;
  setbkcolor(htszin);
  racs;
  keret;
  labirintrajzol;
  ugroido:=600;
  x:=2*tav-1;
  y:=21*tav+3;
  jobbnyuszi(x,y,szin);
  jobbranez:=true;
  r:=0;
end;

procedure magyarazat;
var i:integer;
begin
  setcolor(white);
  rectangle(25,25,320,140);
  outtextxy(30,30,'Gratullok! Talltl egy rpt!');
  outtextxy(30,50,'A rpt az ''r'' bet lenyomsval');
  outtextxy(30,70,'hasznlhatod fel. Ekkor magad el');
  outtextxy(30,90,'dobod, s fel tudsz r ugrani, gy');
  outtextxy(30,110,'mint egy dobozra, de ez a rpa');
  outtextxy(30,130,'ellenll a gravitcinak!');
  repeat until readkey=#13;
  setcolor(falszin);
  for i:=0 to 115 do line(25,25+i,320,25+i)
end;

procedure menu;
begin
  cleardevice;
  keret;
  setbkcolor(htszin);
  setcolor(falszin);
  SetTextJustify(CenterText, CenterText);
  outtextxy(maxX div 2,30,'Nyuszi');
  outtextxy(maxX div 2,50,'1. Els plytl kezds');
  outtextxy(maxX div 2,70,'2. Megadott plytl folytats');
  setcolor(kockaszin);
  outtextxy(maxX div 2,90,'Esc -> Kilps');
end;

procedure maszkalas;
begin
  c:=readkey;
    case c of
    'q': {nyuszi gyorsts}
      begin
        if ugroido>=20 then ugroido:=ugroido-20;
      end;
    'a': {nyuszi lassts}
      begin
        ugroido:=ugroido+20;
      end;
    'k':  {plya jra kezdse}
      begin
        inical(p);
        jobbnyuszi(x,y,szin);
        jobbranez:=true;
      end;
    'r':  {rpa hasznlsa}
      begin
        if r>0 then
        begin
          if jobbranez then
          begin
            ax:=x; ay:=y;
            visszavalt(x,y,i,j);
            if (lab[i,j+1]=0) or (lab[i,j+1]=2) then
            begin
              lab[i,j+1]:=4;
              torles(2,rhtszin);
              atvalt(i,j+1,x,y);
              repa(x,y);
              x:=ax; y:=ay;
              r:=r-1;
              repaszamolas;
            end;
          end
          else {balranz}
          begin
            ax:=x; ay:=y;
            visszavalt(x,y,i,j);
            if (lab[i,j-1]=0) or (lab[i,j-1]=2) then
            begin
              lab[i,j-1]:=4;
              torles(3,rhtszin);
              atvalt(i,j-1,x,y);
              repa(x,y);
              x:=ax; y:=ay;
              r:=r-1;
              repaszamolas;
            end;
          end;
        end;
      end;
    #72:   {-> fel}
     begin
       ax:=x;
       ay:=y;
       case jobbranez of {jobbra fel ugrs}
       true:
         begin
           visszavalt(x,y,i,j);
           if (y>2*tav) and (lab[i-1,j]=0) and ((lab[i-1,j+1]=0) or
           (lab[i-1,j+1]=2)) and ((lab[i,j+1]=3) or (lab[i,j+1]=1) or
           (lab[i,j+1]=4)) then
           begin
             torles(1,htszin);
             jobbunyuszi(x,y-round(tav/2),szin);
             delay(ugroido);
             torles(1,htszin);
             torles(4,htszin);
             x:=x+tav;
             y:=y-tav;
             torles(1,htszin);
             jobbnyuszi(x,y,szin);
             visszavalt(x,y,i,j);
             if lab[i,j]=2 then
             begin
               r:=r+1;
               repaszamolas;
               lab[i,j]:=0;
             end;
             if (i=1) and (j=30) then kilep:=true;
           end;
         end;
       false:  {balra fel ugrs}
         begin
           visszavalt(x,y,i,j);
           if (y>2*tav) and (lab[i-1,j]=0) and ((lab[i-1,j-1]=0)
           or (lab[i-1,j-1]=2)) and ((lab[i,j-1]=3) or (lab[i,j-1]=1) or
           (lab[i,j-1]=4)) then
           begin
             torles(1,htszin);
             balunyuszi(x,y-round(tav/2),szin);
             delay(ugroido);
             torles(1,htszin);
             torles(4,htszin);
             x:=x-tav;
             y:=y-tav;
             torles(1,htszin);
             balnyuszi(x,y,szin);
             visszavalt(x,y,i,j);
             if lab[i,j]=2 then
             begin
               r:=r+1;
               repaszamolas;
               lab[i,j]:=0;
             end;
           end
         end;
       end;
       if (y>2*tav) and (ax=x) and (ay=y) and ((lab[i-1,j]=2) or
       (lab[i-1,j]=0)) then    {nincs hova ugrani}
         begin
           torles(1,htszin);
           if jobbranez then jobbunyuszi(x,y-round(tav/2),szin)
                        else balunyuszi(x,y-round(tav/2),szin);
           delay(ugroido);
           torles(1,htszin);
           torles(4,htszin);
           if jobbranez then jobbnyuszi(x,y,szin)
                        else balnyuszi(x,y,szin);
           if lab[i-1,j]=2 then
           begin
             r:=r+1;
             repaszamolas;
             lab[i-1,j]:=0;
           end;
         end;
     end;
   #77:   {-> jobbra}
     begin
       if not jobbranez then
       begin
         torles(1,htszin);
         jobbnyuszi(x,y,szin);
         jobbranez:=true;
       end
       else
       begin
         visszavalt(x,y,i,j);
         if (x<maxX-2*tav) and ((lab[i,j+1]=0) or (lab[i,j+1]=2) or
            ((lab[i,j+1]=3) and ((lab[i,j+2]=0) or (lab[i,j+2]=2)) and (lab[i-1,j+1]<>3))) then
         begin
           torles(1,htszin);
           jobbunyuszi(x+round(tav/2),y,szin);
           delay(ugroido);
           torles(1,htszin);
           torles(2,htszin);
           x:=x+tav;
           jobbnyuszi(x,y,szin);
           visszavalt(x,y,i,j);
           if lab[i,j]=2 then
           begin
             r:=r+1;
             repaszamolas;
             lab[i,j]:=0;
           end
           else
           if ((lab[i,j]=3) and ((lab[i,j+1]=0) or (lab[i,j+1]=2))) then
           begin
             torles(2,kockaszin);
             lab[i,j+1]:=3;
             lab[i,j]:=0;
             gravitacio('kocka');
           end;
           gravitacio('nyuszko');
           if (i=1) and (j=30) then kilep:=true;
         end;
       end;
     end;
   #75:    {-> balra}
     begin
       if jobbranez then
       begin
         torles(1,htszin);
         balnyuszi(x,y,szin);
         jobbranez:=false;
       end
       else
       begin
         visszavalt(x,y,i,j);
         if (x>tav) and (lab[i,j-1]=0) or (lab[i,j-1]=2) or
         ((lab[i,j-1]=3) and ((lab[i,j-2]=0) or (lab[i,j-2]=2))and (lab[i-1,j-1]<>3)) then
         begin
           torles(1,htszin);
           balunyuszi(x-round(tav/2),y,szin);
           delay(ugroido);
           torles(1,htszin);
           torles(3,htszin);
           x:=x-tav;
           balnyuszi(x,y,szin);
           visszavalt(x,y,i,j);
           if lab[i,j]=2 then
           begin
             r:=r+1;
             repaszamolas;
             lab[i,j]:=0;
             if p=4 then magyarazat;
           end
           else
           if ((lab[i,j]=3) and ((lab[i,j-1]=0) or (lab[i,j-1]=2))) then
           begin
             torles(3,kockaszin);
             lab[i,j-1]:=3;
             lab[i,j]:=0;
             gravitacio('kocka');
           end;
           gravitacio('nyuszko');
         end;
       end;
     end;
   #27: kilep:=true;
    end;
end;

procedure kilepes;
begin
  visszavalt(x,y,i,j);
  if (i=1) and (j=30) and (p<db) then
  begin
    setcolor(white);
    rectangle(35,35,370,70);
    outtextxy(40,40,'Gratullok! Megoldottad ezt a plyt!');
    outtextxy(40,60,'Kvetkez plyhoz nyomj Entert!');
    repeat until readkey=#13;
    kilep:=false;
    p:=p+1;
    inical(p);
    while (not kilep) do maszkalas;
    kilepes;
  end
  else if (p=db) and (j=30) and (i=1) then
    begin
      setcolor(white);
      rectangle(35,35,370,90);
      outtextxy(40,40,'Gratullok! Megoldottad az sszes plyt!');
      outtextxy(40,60,'Kilpshez nyomj Esc-et!');
      outtextxy(40,80,'Menhz nyomj brmilyen ms gombot!');
      repeat until keypressed;
    end
    else
    begin
      setcolor(white);
      rectangle(35,35,340,70);
      outtextxy(40,40,'Kilpshez nyomj Esc-et!');
      outtextxy(40,60,'Menhz nyomj brmilyen ms gombot!');
      repeat until keypressed;
    end;
end;


BEGIN
  db:=6;
  repeat
    kilep:=false;
    grafikaira;
    cleardevice;
    menu;
    c:=readkey;
    case c of
    '1':
      begin
        p:=1;
        inical(p);
        while (not kilep) do maszkalas;
        kilepes;
      end;
    '2':
      begin
        repeat
          setcolor(falszin);
          outtextxy(maxX div 2,120,'Melyik plyn szeretnl jtszani?');
          readln(s);
          val(s,p,ok);
        until (ok=0) and (p<=db) and (p>=1);
        inical(p);
        while (not kilep) do maszkalas;
        kilepes;
      end;
    end;
  until readkey=#27;
END.